#!/usr/bin/perl

# use strict;

# FG Guestbook - gbadmin.pl - written in XEmacs (http://www.xemacs.org/)
#
# Version: 3.1 - 25-Mar-2003
# Author & Copyright: Felix Gertz - felix_gertz@das-fluppt.de
# FG Guestbook homepage: http://fgguestbook.sourceforge.net/
#
# This guestbook is free available, because it stands under the
# GPL (GNU General Public License). See LICENSE for more information.

# ----------- BEGIN MAIN

my $gdata = "./gdata/";

my $passwd_file = $gdata."passwd";

my %params = &get_param();
my $number_of_entries = &get_nb_of_entries($gdata);
my $scriptname = $ENV{'SCRIPT_NAME'};

print "Content-type: text/html\n\n";

if(&check_passwd($params{'admin'},$passwd_file))
  {
    &print_header($gdata,$params{'admin'},$scriptname);

    if($params{'option'} eq 'delete')
      {
	if(($params{'type'} eq 'view') && ($params{'nr'} ne ""))
	  {
	    print &get_single_entry($gdata,$params{'nr'},$number_of_entries);
	  }
	else
	  {
	    if(($params{'type'} eq 'delete') && ($params{'nr'} ne ""))
	      {
		&kill_entry($gdata,$params{'nr'},$number_of_entries);
		$number_of_entries = &get_nb_of_entries($gdata);
	      }
	    &print_numberlist($number_of_entries,$scriptname,$params{'admin'});
	  }
      }
    if($params{'option'} eq 'comment')
      {
	if(($params{'type'} eq 'view') && ($params{'nr'} ne ""))
	  {
	    print &get_single_entry($gdata,$params{'nr'},$number_of_entries);
	  }
	elsif(($params{'type'} eq 'comment') && ($params{'nr'} ne ""))
	  {
	    &print_comment_entry($params{'nr'},$params{'admin'},$scriptname);
	  }
	else
	  {
	    if(($params{'type'} eq 'send') && ($params{'text'} ne ""))
	      {
		&comment_entry($gdata,$params{'nr'},$number_of_entries,$params{'text'});
	      }
	    &print_comment_numberlist($number_of_entries,$scriptname,$params{'admin'});
	  }
      }
    if($params{'option'} eq 'changepasswd')
      {
	if($params{'type'} eq 'change')
	  {
	    unless(&change_passwd($passwd_file,$params{'new_passwd'},$params{'new_passwd_r'}))
	      { &print_error_change_passwd(); }
	    else
	      { &print_ok_change_passwd(); }
	  }
	&print_changepasswd($params{'admin'},$scriptname);
      }
    if($params{'option'} eq 'viewlogs')
      {
	if($params{'type'} eq 'delete') { &delete_log($gdata); }
	&print_viewlogs($params{'admin'},$scriptname,$gdata);
      }
  }
else
  {
    &print_login($gdata,$scriptname,$passwd_file);
  }
print &get_data($gdata,'footer_template');

# ---------- END MAIN

sub print_numberlist
  {
    my $number_of_entries = $_[0];
    my $scriptname = $_[1];
    my $admin = $_[2];
    my $i;

    print << "EOHTML";
<table width="30%" border="1" cellspacing="0" bordercolor="#18246B" bgcolor="#ffcc33" align="center">
<tr>
<td align="center"><b>&nbsp;<font color="#000000">Delete entry</font></b></td>
</tr>
<tr>
<td bgcolor="#FFFFFF">
<table width="100%" border="1" cellspacing="0" bordercolor="#FFFFFF">
<tr bgcolor="#e3e3e3">
<td width="71%" bgcolor="#e5e5e5" align="center">
EOHTML
print "<form action=\"$scriptname\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"admin\" value=\"$admin\">\n";
print "<input type=\"hidden\" name=\"option\" value=\"delete\">\n";
print "<select name=\"nr\" size=\"6\">\n";
for ($i=1;$i<=$number_of_entries;$i++)
  {
    print "<option value=\"$i\"> $i</option>\n";
  }
print << "EOHTML";
</select>
</td>
</tr>
<tr bgcolor="#eeeeee">
<td width="71%" align="center">
<input type="submit" name="type" value="view">&nbsp;<input type="submit" name="type" value="delete">
</form>
</td>
</tr>
</table>
</td>
</tr>
</table>
<br>
EOHTML

}

sub print_comment_numberlist
  {
    my $number_of_entries = $_[0];
    my $scriptname = $_[1];
    my $admin = $_[2];
    my $i;

    print << "EOHTML";
<table width="30%" border="1" cellspacing="0" bordercolor="#18246B" bgcolor="#ffcc33" align="center">
<tr>
<td align="center"><b>&nbsp;<font color="#000000">Comment entry</font></b></td>
</tr>
<tr>
<td bgcolor="#FFFFFF">
<table width="100%" border="1" cellspacing="0" bordercolor="#FFFFFF">
<tr bgcolor="#e3e3e3">
<td width="71%" bgcolor="#e5e5e5" align="center">
EOHTML
print "<form action=\"$scriptname\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"admin\" value=\"$admin\">\n";
print "<input type=\"hidden\" name=\"option\" value=\"comment\">\n";
print "<select name=\"nr\" size=\"6\">\n";
for ($i=1;$i<=$number_of_entries;$i++)
  {
    print "<option value=\"$i\"> $i</option>\n";
  }
print << "EOHTML";
</select>
</td>
</tr>
<tr bgcolor="#eeeeee">
<td width="71%" align="center">
<input type="submit" name="type" value="view">&nbsp;<input type="submit" name="type" value="comment">
</form>
</td>
</tr>
</table>
</td>
</tr>
</table>
<br>
EOHTML

}

sub print_comment_entry
  {
    my $nr = $_[0];
    my $admin = $_[1];
    my $scriptname = $_[2];

print << "EOHTML";
<table width="30%" border="1" cellspacing="0" bordercolor="#18246B" bgcolor="#ffcc33" align="center">
<tr>
<td align="center"><b>&nbsp;<font color="#000000">Comment entry number $nr</font></b></td>
</tr>
<tr>
<td bgcolor="#FFFFFF">
<table width="100%" border="1" cellspacing="0" bordercolor="#FFFFFF">
<tr bgcolor="#e3e3e3">
<td width="71%" bgcolor="#e5e5e5" align="center">
EOHTML

print "<form action=\"$scriptname\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"admin\" value=\"$admin\">\n";
print "<input type=\"hidden\" name=\"option\" value=\"comment\">\n";
print "<input type=\"hidden\" name=\"nr\" value=\"$nr\">\n";
print << "EOHTML";
<textarea rows=5 cols=50 name="text" wrap=physical></textarea>
</td>
</tr>
<tr bgcolor="#eeeeee">
<td width="71%" align="center">
<input type="submit" name="type" value="send">
</form>
</td>
</tr>
</table>
</td>
</tr>
</table>
<br>
EOHTML

  }

sub print_changepasswd
  {
    my $admin = $_[0];
    my $scriptname = $_[1];

print << "EOHTML";
<table width="30%" border="1" cellspacing="0" bordercolor="#18246B" bgcolor="#ffcc33" align="center">
<tr>
<td align="center"><b>&nbsp;<font color="#000000">Change password</font></b></td>
</tr>
<tr>
<td bgcolor="#FFFFFF">
<table width="100%" border="1" cellspacing="0" bordercolor="#FFFFFF">
<tr bgcolor="#e3e3e3">
<td width="71%" bgcolor="#e5e5e5" align="center">
EOHTML

print "<form action=\"$scriptname\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"admin\" value=\"$admin\">\n";
print << "EOHTML";
<input type="hidden" name="option" value="changepasswd">
<table>
<tr>
<td align="right"><font color="#000000">New password:</font></td>
<td align="left"><input type="password" size="10" maxlength="50" name="new_passwd"></td>
</tr>
<tr>
<td align="right"><font color="#000000">Retype:</font></td>
<td align="left"><input type="password" size="10" maxlength="50" name="new_passwd_r"></td>
</tr>
</table>
</td>
</tr>
<tr bgcolor="#eeeeee">
<td width="71%" align="center">
<input type="submit" name="type" value="change">
</form>
</td>
</tr>
</table>
</td>
</tr>
</table>
<br>
EOHTML

  }

sub print_error_change_passwd
  {
print << "EOHTML";
<table width="30%" border="1" cellspacing="0" bordercolor="#18246B" bgcolor="#ffcc33" align="center">
<tr>
<td align="center"><b>&nbsp;<font color="#000000">Error</font></b></td>
</tr>
<tr>
<td bgcolor="#FFFFFF">
<table width="100%" border="1" cellspacing="0" bordercolor="#FFFFFF">
<tr bgcolor="#e3e3e3">
<td width="71%" bgcolor="#e5e5e5" align="center">
<center>
<font color="#000000">
Changeing the password was not successfull!<br>
Maybe your retype was not equal?<br>
Or the length is smaller then 6 signs?<br>
Note: You can only use alphanumeric signs. a-zA-Z0-9_<br>
</font>
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
EOHTML

  }

sub print_ok_change_passwd
  {
print << "EOHTML";
<table width="30%" border="1" cellspacing="0" bordercolor="#18246B" bgcolor="#ffcc33" align="center">
<tr>
<td align="center"><b>&nbsp;<font color="#000000">Success!</font></b></td>
</tr>
<tr>
<td bgcolor="#FFFFFF">
<table width="100%" border="1" cellspacing="0" bordercolor="#FFFFFF">
<tr bgcolor="#e3e3e3">
<td width="71%" bgcolor="#e5e5e5" align="center">
<center>
<font color="#000000">
OK!<br>
Password changed.<br>
</font>
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
EOHTML

  }

sub print_viewlogs
  {
    my $admin = $_[0];
    my $scriptname = $_[1];
    my $gdata = $_[2];

print << "EOHTML";
<table width="30%" border="1" cellspacing="0" bordercolor="#18246B" bgcolor="#ffcc33" align="center">
<tr>
<td align="center"><b>&nbsp;<font color="#000000">View log</font></b></td>
</tr>
<tr>
<td bgcolor="#FFFFFF">
<table width="100%" border="1" cellspacing="0" bordercolor="#FFFFFF">
<tr bgcolor="#e3e3e3">
<td width="71%" bgcolor="#e5e5e5" align="center">
EOHTML

print "<form action=\"$scriptname\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"admin\" value=\"$admin\">\n";
print "<input type=\"hidden\" name=\"option\" value=\"viewlogs\">\n";
print "<textarea name=\"text\" rows=\"10\" cols=\"110\">\n";
print &get_data($gdata,'log');
print << "EOHTML";
</textarea>
</td>
</tr>
<tr bgcolor="#eeeeee">
<td width="71%" align="center">
<input type="submit" name="type" value="delete">
</form>
</td>
</tr>
</table>
</td>
</tr>
</table>
<br>
EOHTML

  }

sub print_header
  {
    my $gdata = $_[0];
    my $admin = $_[1];
    my $scriptname = $_[2];

    print &get_data($gdata,'header_template');
print << "EOHTML";
<br><br>
<table width="30%" border="1" cellspacing="0" bordercolor="#18246B" bgcolor="#ffcc33" align="center">
<tr>
<td align="center"><b>&nbsp;<font color="#000000">Admin Area<br>Options</font></b></td>
</tr>
<tr>
<td bgcolor="#FFFFFF">
<table width="100%" border="1" cellspacing="0" bordercolor="#FFFFFF">
<tr bgcolor="#e3e3e3">
<td width="71%" bgcolor="#e5e5e5" align="center">
EOHTML

print "<form action=\"$scriptname\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"admin\" value=\"$admin\">\n";
print << "EOHTML";
<table>
<tr>
<td align="right"><input type="radio" name="option" value="delete"></td>
<td align="left"><font color="#000000">Delete entry</font></td>
</tr>
<tr>
<td align="right"><input type="radio" name="option" value="comment"></td>
<td align="left"><font color="#000000">Comment entry</font></td>
</tr>
<tr>
<td align="right"><input type="radio" name="option" value="viewlogs"></td>
<td align="left"><font color="#000000">View log</font></td>
</tr>
<tr>
<td align="right"><input type="radio" name="option" value="changepasswd"></td>
<td align="left"><font color="#000000">Change password</font></td>
</tr>
</table>
</td>
</tr>
<tr bgcolor="#eeeeee">
<td width="71%" align="center">
<input type="submit" value="Go!">
</form>
</td>
</tr>
</table>
</td>
</tr>
</table>
EOHTML

  }

sub print_login
  {
    my $gdata = $_[0];
    my $scriptname = $_[1];
    my $passwd_file = $_[2];

    print &get_data($gdata,'header_template');
print << "EOHTML";
<br><br>
<table width="30%" border="1" cellspacing="0" bordercolor="#18246B" bgcolor="#ffcc33" align="center">
<tr>
<td align="center"><b>&nbsp;<font color="#000000">Please login</font></b></td>
</tr>
<tr>
<td bgcolor="#FFFFFF">
<table width="100%" border="1" cellspacing="0" bordercolor="#FFFFFF">
<tr bgcolor="#e3e3e3">
<td width="71%" bgcolor="#e5e5e5" align="center">
EOHTML
if(&check_passwd('fbill98',$passwd_file))
  {
    print "<b>The default password 'fbill98' is still in use.<br>Please change it!<br><b>\n";
  }
print "<form action=\"$scriptname\" method=\"post\">\n";
print << "EOHTML";
<table>
<tr>
<td align="right"><font color="#000000">Password:</font></td>
<td align="left"><input type="password" name="admin" maxlength="50" size="10"></td>
</table>
</td>
</tr>
<tr bgcolor="#eeeeee">
<td width="71%" align="center">
<input type="submit" value="login">
</form>
</td>
</tr>
</table>
</td>
</tr>
</table>
EOHTML

  }

sub get_data
  {
    my $gdata = $_[0];
    my $file = $_[1];
    my $filename = $gdata.$file;
    my @data = ("");

    unless(open (DATA, "<$filename") || ($file eq 'log')) { &common_error($filename); }
    while(<DATA>)
      { push(@data,$_); }
    close(DATA);

    return @data;
  }

sub get_param
  {
    my $data;
    my $name;
    my $value;
    my $formularfield;
    my @formularfields = ("");
    my %params;

    read(STDIN, $data, $ENV{'CONTENT_LENGTH'}); 

    @formularfields = split(/&/,$data);

    foreach $formularfield (@formularfields)
      {
	($name,$value) = split(/=/, $formularfield);
	$params{$name} = $value;
      }

    return %params;
  }

sub common_error
  {
    my $catchword = $_[0];

    print "Content-type: text/html\n\n";
    print "<html>\n<head>\n<title>Guestbook error</title>\n</head>\n<body>\n";
    print "An error has accourd!<br>\nMaybe, a file couldn't be read or written?<br>\nOr another user accesses a file in the same time as you.<br><br>\nHere is a catchword:<br>\n";
    print $catchword;
    print "<br>\n</body>\n</html>\n";

    die;
  }

sub get_nb_of_entries
  {
    my $gdata = $_[0];
    my $filename = $gdata.'count';
    my $count;

    unless(open (COUNT, "<$filename")) { &common_error('get_nb_of_entries'); }
    $count = <COUNT>;
    close(COUNT);
    chomp($count);
    return $count;
  }

sub get_single_entry
  {
    my $gdata = $_[0];
    my $nr = $_[1];
    my @data = ("");
    my $lcount = $_[2]+1;
    my $line;
    my @entry = ("");

    unless($nr)
      { return "<br><br><center>No entry selected</center><br>\n" }

    @data = &get_data($gdata,'data');

    foreach $line (@data)
      {
        if ($line=~ s/!R//g) { $lcount--; }
	$line =~ s/\%NUMBER\%/$lcount/g;
	$line =~ s/\%ITTIMESTRING\%//g;
	$line =~ s/\%COMMENT\%//g;
	$line =~ s/\%BRCOMMENT\%//g;

        if($lcount eq $nr) { push (@entry,$line); }
      }

    return @entry;
  }

sub kill_entry
  {
    my $gdata = $_[0];
    my $nr = $_[1];
    my $number_of_entries = $_[2];
    my $countfilename = $gdata.'count';
    my $datafilename = $gdata.'data';
    my @data = ("");
    my @data2 = ("");
    my $lcount = $number_of_entries+1;
    my $line;

    @data = &get_data($gdata,'data');

    foreach $line (@data)
      {
        if ($line=~ /!R/)
	  { $lcount--; }

        if($lcount ne $nr)
	  { push (@data2,$line); }
      }

    unless(open(DATA,">$datafilename")) { &commonerror($datafilename); }
    flock(DATA,1);
    print DATA @data2;
    flock(DATA,8);
    close(DATA);

    unless(open(COUNT, ">$countfilename")) { &common_error($countfilename); }
    flock(COUNT,1);
    print COUNT $number_of_entries-1;
    flock(COUNT,8);
    close (COUNT);

  }

sub delete_log
  {
    my $gdata = $_[0];
    my $filename = $gdata.'log';

    unlink $filename;
  }

sub get_passwdline
  {
    my $passwd_file = $_[0];
    my $encrypted_passwd;

    unless(open(PASS,"<$passwd_file")) { &common_error('get_passwdline'); }
    $encrypted_passwd = <PASS>;
    close(PASS);
    chomp($encrypted_passwd);
    return $encrypted_passwd;
  }

sub check_passwd
  {
    my $admin = $_[0];
    my $passwd_file = $_[1];
    my $encrypted_admin;
    my $encrypted_passwd = &get_passwdline($passwd_file);

    $encrypted_admin = crypt($admin,substr($encrypted_passwd,0,2));

    unless($encrypted_admin eq $encrypted_passwd)
      {
	unless(($admin eq "") || ($admin eq "fbill98")) { sleep 5; }
	return 0;
      }

    return 1;
  }

sub change_passwd
  {
    my $passwd_file = $_[0];
    my $new_passwd = $_[1];
    my $r_new_passwd = $_[2];
    my $encrypted_new_passwd;
    my $encrypted_old_passwd = &get_passwdline($passwd_file);

    if($new_passwd eq "") { return 0; }
    unless($new_passwd eq $r_new_passwd) { return 0; }
    if($new_passwd =~ /\W/) { return 0; }
    if(length($new_passwd) < 6) { return 0; }

    $encrypted_new_passwd = crypt($new_passwd,substr($encrypted_old_passwd,0,2));

    open(PASS,">$passwd_file") || return 0;
    flock(PASS,1);
    print PASS $encrypted_new_passwd,"\n";
    flock(PASS,8);
    close(PASS);

    return 1;
  }

sub comment_entry
  {
    my $gdata = $_[0];
    my $nr = $_[1];
    my $count = $_[2]+1;
    my $text = $_[3];
    my $filename = $gdata.'data';
    my @data = &get_data($gdata,'data');
    my @data_new = ("");
    my $line;

    $text =~ tr/+/ /;
    $text =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $text =~ s/\n/<br>/g;
    $text =~ s/http:\/\/([a-zA-Z_0-9.\-\/\?\=\&\%]*)/<a href=\"http:\/\/$1\" target=\"_blank\">http:\/\/$1<\/a>/g;

    $text = "<i>".$text."</i>";

    foreach $line(@data)
      {
	  if ($line=~ /!R/)
	  { $count--; }

	  if($count eq $nr)
	    {
	      $line =~ s/\%BRCOMMENT\%/<br><br>$text/g;
	      $line =~ s/\%COMMENT\%/$text/g;
	    }
	  push(@data_new,$line);
      }

    unless(open(DATA,">$filename")) { &common_error($filename); }
    flock(DATA,1);
    print DATA @data_new;
    flock(DATA,8);
    close(DATA);
  }
